--thanks goes to the author of SpellReminder for the great idea
KeepItCool = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceConsole-2.0", "AceEvent-2.0")
local candybar = AceLibrary("CandyBar-2.0")
local sm = AceLibrary("SharedMedia-1.0")
local li = AceLibrary("LibCooldown-Item-1.0")
local ls = AceLibrary("LibCooldown-Spell-1.0")
local self = KeepItCool

local function getOption(key)
	return KeepItCool.db.profile[key]
end
local function setOption(key, value)
	KeepItCool.db.profile[key] = value
end
KeepItCool.options = {
	type = "group",
	name = "KeepItCool",
	desc = "Options for KeepItCool",
	handler = KeepItCool,
	args = {
		toggle = {
			type = "execute",
			name = "toggle",
			desc = "Toggle the anchors",
			func = "ToggleAnchors",
		},
		texture = {
			type = "text",
			name = "Texture",
			desc = "Set the Cast Bar Texture",
			validate = sm:List("statusbar"),
			order = 12,
			get = getOption,
			set = setOption,
			passValue = "texture",
		},
		startScale = {
			type = "range",
			name = "Start scale",
			desc = "Set the scale of the normal bar",
			max = 3.0,
			min = 1.0,
			step = 0.01,
			isPercent = true,
			get = getOption,
			set = setOption,
			passValue = "initBarScale",
		},
		emphasizeScale = {
			type = "range",
			name = "Emphasize scale",
			desc = "Set the scale of the emphasize bar",
			max = 3.0,
			min = 1.0,
			step = 0.01,
			isPercent = true,
			get = getOption,
			set = setOption,
			passValue = "resizeBarScale",
		},
		[[normalWidth = {
			type = "range",
			name = "Normal width",
			desc = "Set the width of the normal bar",
			max = 500,
			min = 50,
			step = 1,
			get = getOption,
			set = setOption,
			passValue = "initBarWidth",
		},
		normalHight = {
			type = "range",
			name = "Normal hight",
			desc = "Set the hight of the normal bar",
			max = 200,
			min = 5,
			step = 1,
			get = getOption,
			set = setOption,
			passValue = "initBarHight",
		},
		emphasizeWidth = {
			type = "range",
			name = "Emphasize width",
			desc = "Set the width of the emphasize bar",
			max = 500,
			min = 50,
			step = 1,
			get = getOption,
			set = setOption,
			passValue = "resizeBarWidth",
		},
		emphasizeHight = {
			type = "range",
			name = "Emphasize hight",
			desc = "Set the hight of the emphasize bar",
			max = 200,
			min = 5,
			step = 1,
			get = getOption,
			set = setOption,
			passValue = "resizeBarHight",
		},]]
		
	},
}

KeepItCool:RegisterDB("KeepItCoolDB")
KeepItCool:RegisterDefaults("profile",{
	initBarScale = 1.0,
	resizeBarScale = 2.0,
	initBarFont = nil,
	resizeBarFont = nil,
	debug = false,
	texture = "Flat",
	barposition	= { resizeBar = {}, normalBar = {}},
})

function KeepItCool:out(text)
	if not self.db.profile.debug then return; end
	DEFAULT_CHAT_FRAME:AddMessage(text)
end

function KeepItCool:OnInitialize()
	self:CreateAnchors()
	self:RegisterEvent("KeepItCoolGrow")
	self:RegisterEvent("LibCD_SpellCooldownStart", "SpellCooldownStart")
	self:RegisterEvent("LibCD_SpellCooldownEnd", "SpellCooldownEnd")
	self:RegisterEvent("LibCD_ItemCooldownStart", "ItemCooldownStart")
	self:RegisterEvent("LibCD_ItemCooldownEnd", "ItemCooldownEnd")
	--self:RegisterEvent("LibCD_EquippedItemCooldownStart", "EquipedItemsStart")
	self:RegisterSpells()
	self:RegisterChatCommand({'/KeepItCool', '/kic'}, self.options)
end

function KeepItCool:RegisterSpells()
	ls:AddAllSpellCooldowns()
	li:AddAllItemCooldowns()
end
function KeepItCool:EquipedItemsStart(itemName, itemID, duration, slotID)
	local texture = select(10, GetItemInfo(itemID))
	candybar:RegisterCandyBar(itemName..itemID, duration, itemName, texture)
	candybar:RegisterCandyBarWithGroup(itemName..itemID, "KeepItCoolNormal")
	candybar:StartCandyBar(itemName..itemID, true)
	candybar:SetCandyBarTexture(itemName..itemID, sm:Fetch("statusbar", self.db.profile.texture))
	if duration < 20 then
		self:ScheduleEvent("KeepItCoolGrow"..itemID, self.KeepItCoolGrow, duration -3, self, itemName..itemID)
	else
		self:ScheduleEvent("KeepItCoolGrow"..itemID, self.KeepItCoolGrow, duration * 0.8, self , itemName..itemID)
	end
end

function KeepItCool:SpellCooldownStart(spellName, spellID, duration)
	if duration < 2.0 then return; end
	self:out(spellName)
	--self:out("SpellCooldownStart")
	local texture = GetSpellTexture(spellID, "BOOKTYPE_SPELL")
	candybar:RegisterCandyBar(spellName..spellID, duration, spellName, texture)
	candybar:RegisterCandyBarWithGroup(spellName..spellID, "KeepItCoolNormal")

	candybar:StartCandyBar(spellName..spellID, true)
	candybar:SetCandyBarTexture(spellName..spellID, sm:Fetch("statusbar", self.db.profile.texture))
	if duration < 20 then
		self:ScheduleEvent("KeepItCoolGrow"..spellID, self.KeepItCoolGrow, duration -3, self, spellName..spellID)
	else
		self:ScheduleEvent("KeepItCoolGrow"..spellID, self.KeepItCoolGrow, duration-10, self , spellName..spellID)
	end
end

function KeepItCool:KeepItCoolGrow(id)
	self:ScheduleEvent("KeepItCoolGrowBar_"..id,self.GrowBar,0,self,id,GetTime()+0.5)
end

function KeepItCool:GrowBar(id, stopTime)
	if not candybar:IsCandyBarRegistered(id) then return end
	if GetTime() > stopTime then
		candybar:SetCandyBarScale(id,getOption("resizeBarScale"))
		candybar:RegisterCandyBarWithGroup(id,"KeepItCoolResize")
		return
	end
	local now = GetTime()
	local scale = (getOption("resizeBarScale") - getOption("initBarScale")) * (1 - ((stopTime - now) / 0.5))

	--local centerX, centerY = self:GetCandyBarCenter(id)
	candybar:SetCandyBarScale(id,1.0 + scale)
	local effscale = UIParent:GetEffectiveScale()
	--local effscale = candybar:GetCandyBarEffectiveScale(id)
	local point, _, anchor, rx, ry = self.resizeBar:GetPoint()
	local point, _, anchor, nx, ny = self.normalBar:GetPoint()
	local posX = ((rx*effscale) - (nx*effscale)) * (1-((stopTime - now) / 0.5)) 
	local posY = ((ry*effscale) - (ny*effscale)) * (1-((stopTime - now) / 0.5))

	local point, rframe, rpoint = candybar:GetCandyBarPoint(id)
	candybar:SetCandyBarPoint(id, point, rframe, rpoint, posX*effscale, posY*effscale)
--	candybar:SetCandyBarPoint(id, point, rframe, rpoint, posX/effscale, posY/effscale)
	
	self:ScheduleEvent("KeepItCoolGrowBar_"..id,self.GrowBar,0,self,id,stopTime)
end
function KeepItCool:SpellCooldownEnd(spellName, spellID, startTime)
	candybar:StopCandyBar(spellName..spellID)
	candybar:UnregisterCandyBar(spellName..spellID)
end
local potion = false
local stone = false
local potionids = {
	118,
	858,
	929,
	1710,
	3928,
	4596,
	13446,
	17348,
	17349,
	18839,
	22829,
	13462,
	13461,
	13457,
	13456,
	13460,
	13458,
	13459,
	13444,
	20002,
	18253,
	28100,
	22826,
	22828,
	32947,
	22829,
	23822,
	33092,
	22871,
	32948,
	22832,
	31676,
	23823,
	33093,
	22839,
	22838,
	22837,
	31838,
	31839,
	31852,
	31853,
	31840,
	31841,
	31855,
	22836,
	31677,
	22845,
	32840,
	22841,
	32846,
	22842,
	32847,
	22847,
	22844,
	22846,
	32845,
	22849,
	22850,
	118,
	858,
	5631,
	4596,
	2455,
	2456,
	2459,
	23871,
	929,
	3385,
	6048,
	5634,
	1710,
	3827,
	6049,
	5633,
	6050,
	6052,
	6149,
	32905,
}

local stoneids = {
	5510,
	19010,
	19011,
	5509,
	19008,
	19009,
	5511,
	19006,
	19007,
	9421,
	19012,
	19013,
	22103,
	22104,
	22105,
	5512,
	19004,
	19005,
	20520,
	12662,
	32902,
}
function KeepItCool:ItemCooldownStart(itemName, itemID, duration, bagID, slotID)
	local texture = nil
	if not potion then
		for k,v in ipairs(potionids) do
			if tonumber(v) == tonumber(itemID) then
				texture = select(10, GetItemInfo(22832))
				itemName = "Potions"
				self:out("found")
				potion = true
			end
		end
	end
	if not stone then
		for k,v in ipairs(stoneids) do
			if v == itemID then
				texture = select(10, GetItemInfo(6990))
				itemName = "Stones"
				stone = true
			end
		end
	end
	if not texture and bagID then return; end
	if not texture then
		texture = select(10, GetItemInfo(itemID))
	end
	self:out(texture)
	candybar:RegisterCandyBar(itemName..itemID, duration, itemName, texture)
	candybar:RegisterCandyBarWithGroup(itemName..itemID, "KeepItCoolNormal")
	candybar:StartCandyBar(itemName..itemID, true)
	candybar:SetCandyBarTexture(itemName..itemID, sm:Fetch("statusbar", self.db.profile.texture))
	if duration < 20 then
		self:ScheduleEvent("KeepItCoolGrow"..itemID, self.KeepItCoolGrow, duration -3, self, itemName..itemID)
	else
		self:ScheduleEvent("KeepItCoolGrow"..itemID, self.KeepItCoolGrow, duration * 0.8, self , itemName..itemID)
	end
end

function KeepItCool:ItemCooldownEnd(itemName, itemID, startTime, bagID, slotID)
	candybar:StopCandyBar(itemName..itemID)
	candybar:UnregisterCandyBar(itemName..itemID)
	local texture = select(10, GetItemInfo(itemID))
	if texture == "Interface\\Icons\\INV_Stone_137" then
		potion = false
	elseif texture == "Interface\\Icons\\INV_Stone_04" then
		stone = false
	end
end

function KeepItCool:CreateAnchors()
	self.normalBar = self:CreateAnchor("normalBar", "Normal Bar", 1, 1, 1)
	self.resizeBar = self:CreateAnchor("resizeBar", "Emphasize Bar", 1, 1, 1)
	
	-- CandyBar
	-- normal bar
	candybar:RegisterCandyBarGroup("KeepItCoolNormal")
	candybar:SetCandyBarGroupPoint("KeepItCoolNormal", "TOP", self.normalBar, "BOTTOM", 0, 0)
	-- resize Bar
	candybar:RegisterCandyBarGroup("KeepItCoolResize")
	candybar:SetCandyBarGroupPoint("KeepItCoolResize", "TOP", self.resizeBar, "BOTTOM", 0, 0)
	
end
local show = false
function KeepItCool:ToggleAnchors()
	if not show then
		self.normalBar:Show()
		self.resizeBar:Show()
	else
		self.normalBar:Hide()
		self.resizeBar:Hide()
	end
	show = not show
end


function KeepItCool:SaveAnchorPositions()
	local s = this:GetEffectiveScale()
	local point, _, anchor, x, y = self.normalBar:GetPoint()
	self.db.profile.barposition["normalBar"].x = x * s
	self.db.profile.barposition["normalBar"].y = y * s
	self.db.profile.barposition["normalBar"].anchor = anchor
	self.db.profile.barposition["normalBar"].point = point
	
	local point, _, anchor, x, y = self.resizeBar:GetPoint()
	self.db.profile.barposition["resizeBar"].x = x * s
	self.db.profile.barposition["resizeBar"].y = y * s
	self.db.profile.barposition["resizeBar"].anchor = anchor
	self.db.profile.barposition["resizeBar"].point = point
end

function KeepItCool:CreateAnchor(name, text, r, g, b)
		local f = CreateFrame("Button", "KeepItCool_"..name.."Anchor", UIParent)
	f:SetWidth(200)
	f:SetHeight(25)

	f.owner = self

	local s = this:GetEffectiveScale()
	f:ClearAllPoints()
	if self.db.profile.barposition[name].x and self.db.profile.barposition[name].y and self.db.profile.barposition[name].point and self.db.profile.barposition[name].anchor then
		f:SetPoint(self.db.profile.barposition[name].point, UIParent, self.db.profile.barposition[name].anchor, self.db.profile.barposition[name].x/s, self.db.profile.barposition[name].y/s)
	else
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 50/s)
	end

	f:SetScript("OnDragStart", function() this:StartMoving() end )
	f:SetScript("OnDragStop",
		function()
			this:StopMovingOrSizing()
			self:SaveAnchorPositions()
        end)

	f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                                            tile = false, tileSize = 16, edgeSize = 16,
                                            insets = { left = 5, right =5, top = 5, bottom = 5 }})
	f:SetBackdropColor(cRed,cGreen,cBlue,.6)
	f:SetMovable(true)
	f:RegisterForDrag("LeftButton")

	f.Text = f:CreateFontString(nil, "OVERLAY")
	f.Text:SetFontObject(GameFontNormalSmall)
	f.Text:ClearAllPoints()
	f.Text:SetTextColor(1, 1, 1, 1)
	f.Text:SetWidth(200)
	f.Text:SetHeight(25)
	f.Text:SetPoint("TOPLEFT", f, "TOPLEFT")
	f.Text:SetJustifyH("CENTER")
	f.Text:SetJustifyV("MIDDLE")
	f.Text:SetText(text)

	f:Hide()

	return f
end
